=== debian/changelog ===
xeus (0.24.2-2) unstable; urgency=medium

  * Source-only upload

 -- Gordon Ball <gordon@chronitis.net>  Thu, 29 Oct 2020 20:21:39 +0000

xeus (0.24.2-1) unstable; urgency=medium

  * Initial release. (Closes: #973041)

 -- Gordon Ball <gordon@chronitis.net>  Tue, 27 Oct 2020 19:44:43 +0000
