=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DXEUS_DISABLE_ARCH_NATIVE=1 -DGTEST_SRC_DIR=/usr/src/googletest
