## xeus 0.25.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -121,7 +121,9 @@
     ${XEUS_INCLUDE_DIR}/xeus/xauthentication.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xcomm.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xcontrol_messenger.hpp
+    ${XEUS_INCLUDE_DIR}/xeus/xdap_tcp_client.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xdebugger.hpp
+    ${XEUS_INCLUDE_DIR}/xeus/xdebugger_base.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xeus.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xguid.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xhistory_manager.hpp
@@ -147,7 +149,9 @@
     ${XEUS_SOURCE_DIR}/xcontrol.hpp
     ${XEUS_SOURCE_DIR}/xcontrol.cpp
     ${XEUS_SOURCE_DIR}/xcontrol_messenger.cpp
+    ${XEUS_SOURCE_DIR}/xdap_tcp_client.cpp
     ${XEUS_SOURCE_DIR}/xdebugger.cpp
+    ${XEUS_SOURCE_DIR}/xdebugger_base.cpp
     ${XEUS_SOURCE_DIR}/xguid.cpp
     ${XEUS_SOURCE_DIR}/xheartbeat.cpp
     ${XEUS_SOURCE_DIR}/xheartbeat.hpp
@@ -323,6 +327,3 @@
     endif ()
 
     if (MSVC)
-        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
-        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
-        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
