=== debian/changelog ===
xeus (0.25.0-1) unstable; urgency=medium

  * New upstream version 0.25.0
  * Add patches:
     + Retain compatibility for cppzmq 4.6.0
     + Disable -march=native for tests to avoid warnings
  * Fix FTBFS with nocheck profile, patch from Helmut Grohne (Closes: #973982)

 -- Gordon Ball <gordon@chronitis.net>  Fri, 20 Nov 2020 20:10:24 +0000
