## xeus 0.25.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -293,32 +293,6 @@
             target_compile_options(${target_name} PUBLIC -march=native)
         endif ()
 
-        # Enable link time optimization and set the default symbol
-        # visibility to hidden (very important to obtain small binaries)
-        if (NOT ${U_CMAKE_BUILD_TYPE} MATCHES DEBUG)
-            # Check for Link Time Optimization support
-            # (GCC/Clang)
-            CHECK_CXX_COMPILER_FLAG("-flto" HAS_LTO_FLAG)
-            if (HAS_LTO_FLAG)
-                target_compile_options(${target_name} PUBLIC -flto)
-            endif ()
-
-            # Avoids removing symbols from the static library
-            CHECK_CXX_COMPILER_FLAG("-ffat-lto-objects" HAS_FATLTO_FLAG)
-            if (${linkage_upper} MATCHES "STATIC" AND  HAS_FATLTO_FLAG)
-                message(STATUS "ENABLE FAT LTO OBJECTS")
-                target_compile_options(${target_name} PUBLIC -ffat-lto-objects)
-            endif ()
-
-            # Intel equivalent to LTO is called IPO
-            if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-                CHECK_CXX_COMPILER_FLAG("-ipo" HAS_IPO_FLAG)
-                if (HAS_IPO_FLAG)
-                    target_compile_options(${target_name} PUBLIC -ipo)
-                endif ()
-            endif ()
-        endif ()
-
         message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
     endif()
 
@@ -327,3 +301,33 @@
     endif ()
 
     if (MSVC)
+        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
+        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
+        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
+    elseif (APPLE)
+        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
+    else ()
+        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
+    endif ()
+
+    if (XEUS_STATIC_DEPENDENCIES AND CMAKE_DL_LIBS)
+        target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS} util rt)
+    endif ()
+
+endmacro()
+
+set(xeus_targets "")
+
+if (XEUS_BUILD_SHARED_LIBS)
+    xeus_create_target(xeus SHARED xeus)
+    if(CMAKE_TARGET_SYSTEM MATCHES "Linux" AND OPENSSL_USE_STATIC_LIBS)
+        # Do not reexport OpenSSL symbols from xeus, for libraries
+        #   Prevents conflicts with other versions of OpenSSL
+        #   loaded in the same process namespace, which can cause
+        #   crashes if the versions are not compatible.
+        set_target_properties(xeus PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,libcrypto.a")
+    endif()
+    list(APPEND xeus_targets xeus)
+endif ()
+
+if (XEUS_BUILD_STATIC_LIBS)
