=== debian/changelog ===
xeus (0.25.3-1) unstable; urgency=medium

  * New upstream version 0.25.3

 -- Gordon Ball <gordon@chronitis.net>  Fri, 11 Dec 2020 12:58:55 +0000
