=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus/tags .*/archive/([\d\.-]+)\.tar\.gz
