## xeus 1.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -72,7 +72,7 @@
 # ============
 
 set(nlohmann_json_REQUIRED_VERSION 3.2.0)
-set(xtl_REQUIRED_VERSION 0.5)
+set(xtl_REQUIRED_VERSION 0.7)
 set(cppzmq_REQUIRED_VERSION 4.4.1)
 set(zeromq_REQUIRED_VERSION 4.3.2)
 
@@ -267,16 +267,35 @@
         endif ()
     endif ()
 
-    set_target_properties(
-        ${target_name}
-        PROPERTIES
-        PUBLIC_HEADER "${XEUS_HEADERS}"
-        COMPILE_DEFINITIONS "XEUS_EXPORTS"
-        PREFIX ""
-        VERSION ${XEUS_BINARY_VERSION}
-        SOVERSION ${XEUS_BINARY_CURRENT}
-        OUTPUT_NAME "lib${output_name}"
-    )
+    if (UNIX)
+        # CMake does not compute the version number of so files as libtool
+        # does on Linux. Strictly speaking, we should exclude FreeBSD and
+        # Apple from this, but that would require having different version
+        # numbers depending on the platform. We prefer to follow the
+        # libtool pattern everywhere.
+        math(EXPR XEUS_BINARY_COMPATIBLE "${XEUS_BINARY_CURRENT} - ${XEUS_BINARY_AGE}")
+        set_target_properties(
+            ${target_name}
+            PROPERTIES
+            PUBLIC_HEADER "${XEUS_HEADERS}"
+            COMPILE_DEFINITIONS "XEUS_EXPORTS"
+            PREFIX ""
+            VERSION "${XEUS_BINARY_COMPATIBLE}.${XEUS_BINARY_REVISION}.${XEUS_BINARY_AGE}"
+            SOVERSION ${XEUS_BINARY_COMPATIBLE}
+            OUTPUT_NAME "lib${output_name}"
+        )
+    else()
+        set_target_properties(
+            ${target_name}
+            PROPERTIES
+            PUBLIC_HEADER "${XEUS_HEADERS}"
+            COMPILE_DEFINITIONS "XEUS_EXPORTS"
+            PREFIX ""
+            VERSION ${XEUS_BINARY_VERSION}
+            SOVERSION ${XEUS_BINARY_CURRENT}
+            OUTPUT_NAME "lib${output_name}"
+        )
+    endif()
 
     # Compilation flags
     # =================
@@ -305,29 +324,3 @@
         target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
         target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
     elseif (APPLE)
-        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
-    else ()
-        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
-    endif ()
-
-    if (XEUS_STATIC_DEPENDENCIES AND CMAKE_DL_LIBS)
-        target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS} util rt)
-    endif ()
-
-endmacro()
-
-set(xeus_targets "")
-
-if (XEUS_BUILD_SHARED_LIBS)
-    xeus_create_target(xeus SHARED xeus)
-    if(CMAKE_TARGET_SYSTEM MATCHES "Linux" AND OPENSSL_USE_STATIC_LIBS)
-        # Do not reexport OpenSSL symbols from xeus, for libraries
-        #   Prevents conflicts with other versions of OpenSSL
-        #   loaded in the same process namespace, which can cause
-        #   crashes if the versions are not compatible.
-        set_target_properties(xeus PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,libcrypto.a")
-    endif()
-    list(APPEND xeus_targets xeus)
-endif ()
-
-if (XEUS_BUILD_STATIC_LIBS)
