=== debian/changelog ===
xeus (1.0.4-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Wed, 24 Nov 2021 12:26:35 +0100

xeus (1.0.4-1) unstable; urgency=medium

  * d/watch: new github tarball URL
  * d/control: version dependency on xtl-dev (>= 0.7)
  * New upstream version 1.0.4
  * Refresh patches

 -- Gordon Ball <gordon@chronitis.net>  Sat, 09 Oct 2021 21:00:24 +0000
