=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libzmq3-dev,
-               xtl-dev,
+               xtl-dev (>= 0.7~),
                nlohmann-json3-dev,
                uuid-dev,
                libssl-dev,
